'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = reactive;

var _preact = require('preact');

var _flyd = require('flyd');

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function reactive() {
  var tag = arguments.length <= 0 || arguments[0] === undefined ? '' : arguments[0];

  var ReactiveClass = function (_Component) {
    _inherits(ReactiveClass, _Component);

    function ReactiveClass(props) {
      _classCallCheck(this, ReactiveClass);

      var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(ReactiveClass).call(this, props));

      _this.state = {};
      return _this;
    }

    _createClass(ReactiveClass, [{
      key: 'componentWillMount',
      value: function componentWillMount() {
        this.subscribe(this.props);
      }
    }, {
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        this.subscribe(nextProps);
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        this.unsubscribe();
      }
    }, {
      key: 'addPropListener',
      value: function addPropListener(name, prop$) {
        var _this2 = this;

        return (0, _flyd.on)(function (value) {
          // don't re-render if value is the same.
          if (value === _this2.state[name]) {
            return;
          }
          _this2.setState(_defineProperty({}, name, value));
        }, prop$);
      }
    }, {
      key: 'subscribe',
      value: function subscribe(props) {
        var _this3 = this;

        if (this.subscriptions) {
          this.unsubscribe();
        }

        this.subscriptions = [];

        Object.keys(props).forEach(function (key) {
          var value = props[key];
          if ((0, _flyd.isStream)(value)) {
            var subscription = _this3.addPropListener(key, value);
            _this3.subscriptions.push(subscription);
          }
        });
      }
    }, {
      key: 'unsubscribe',
      value: function unsubscribe() {
        this.subscriptions.forEach(function (subscription) {
          return subscription.end();
        });
        this.state = {};
        this.subscriptions = null;
      }
    }, {
      key: 'render',
      value: function render() {
        var _props$state = _extends({}, this.props, this.state);

        var children = _props$state.children$;

        var props = _objectWithoutProperties(_props$state, ['children$']);

        var finalProps = _extends({}, props, { children: children });
        if (tag) {
          return (0, _preact.h)(tag, finalProps);
        }
        return (0, _preact.h)(children.nodeName, _extends({}, children.attributes, { props: props }));
      }
    }]);

    return ReactiveClass;
  }(_preact.Component);

  return ReactiveClass;
}